static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xC6, 0x0A, 0xB9, 0xD3, 0x1C, 0x9E, 0xD4, 0xB6, 0xDC, 0xC2,
        0x8D, 0x71, 0xC9, 0x7D, 0x5A, 0xD9, 0xB8, 0xA3, 0x07, 0x9C,
        0x5F, 0x84, 0x84, 0xC3, 0x23, 0x9A, 0x2D, 0x48, 0x37, 0x44,
        0x85, 0xC3, 0x5B, 0xC7, 0x1C, 0xE5, 0xA7, 0x2D, 0xF2, 0xEC,
        0xFE, 0x7A, 0x76, 0x3A, 0xFA, 0xEB, 0x7A, 0x55, 0x2A, 0x4C,
        0x0B, 0x76, 0xA2, 0x25, 0x1D, 0x78, 0x07, 0xAA, 0x0D, 0x57,
        0x33, 0xCD, 0xFC, 0xD3
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
